package dk.vajhoej.vbisam;

import dk.vajhoej.isam.IsamException;
import dk.vajhoej.isam.local.NativeIsam;

public class VBISAM implements NativeIsam {
	//private static final int ISFIRST = 0;
	//private static final int ISLAST = 1;
	private static final int ISNEXT = 2;
	//private static final int ISPREV = 3;
	//private static final int ISCURR = 4;
	private static final int ISEQUAL = 5;
	//private static final int ISGREAT = 6;
	private static final int ISGTEQ = 7;
	private static final int ISINPUT = 0;
	//private static final int ISOUTPUT = 1;
	private static final int ISINOUT = 2;
	//private static final int ISTRANS = 4;
	//private static final int ISNOLOG = 8;
	//private static final int ISVARLEN = 16;
	private static final int ISFIXLEN = 0;
	private int db;
	@Override
	public void open(String fnm, boolean readonly) throws IsamException {
		db = NativeAPI.isopen(fnm, ISFIXLEN + (readonly ? ISINPUT : ISINOUT));
	}
	@Override
	public int read(byte[] buf) throws IsamException {
		return NativeAPI.isread(db, buf, ISEQUAL) == 0 ? buf.length : -1;
	}
	@Override
	public int read(int ix, Object k, byte[] buf) throws IsamException {
		throw new IsamException("Read with key not supported");
	}
	@Override
	public int create(byte[] buf) throws IsamException {
		return NativeAPI.iswrite(db, buf) == 0 ? buf.length : -1;
	}
	@Override
	public int create(byte[] buf, int ix, Object k) throws IsamException {
		throw new IsamException("Create with key not supported");
	}
	@Override
	public int update(byte[] buf) throws IsamException {
		return NativeAPI.isrewrite(db, buf) == 0 ? buf.length : -1;
	}
	@Override
	public int update(byte[] buf, int ix, Object k) throws IsamException {
		throw new IsamException("Update with key not supported");
	}
	@Override
    public int delete(byte[] buf) throws IsamException {
		return NativeAPI.isdelete(db, buf) == 0 ? 1 : -1;
    }
	@Override
	public int delete(int ix, Object k) throws IsamException {
    	throw new IsamException("Delete with key not supported");
	}
	@Override
	public int find(int comp, byte[] buf) throws IsamException {
		return NativeAPI.isread(db, buf, ISGTEQ) == 0 ? buf.length : -1;
	}
	@Override
	public int find(int ix, Object k, int comp, byte[] buf) throws IsamException {
		throw new IsamException("Find with key not supported");
	}
	@Override
	public int findnext(byte[] buf) throws IsamException {
		return NativeAPI.isread(db, buf, ISNEXT) == 0 ? buf.length : -1;
	}
	@Override
	public void close() throws IsamException {
		NativeAPI.isclose(db);
	}
	@Override
	public boolean supportReverse() {
		return false;
	}
	@Override
	public boolean supportFindMixedOther() {
		return false;
	}
	@Override
	public boolean supportReadWithKey() {
		return false;
	}
	@Override
	public boolean supportCreateWithKey() {
		return false;
	}
	@Override
	public boolean supportUpdateWithKey() {
		return false;
	}
	@Override
	public boolean supportDeleteWithKey() {
		return false;
	}
	@Override
	public boolean supportFindWithKey() {
		return false;
	}
}
